//*************************************************************************************
// 	: SQ7617_DIC.c
// 汾		: V1.0
// 		: DIC ʹú
// ע		: DIC غ㼯ڱӳ
//**************************************************************************************
#include "main.h"

// Array to keep the crc checksum for sequence 1
unsigned char dic_crc[4];				   	// 1CRC
// Array to keep the crc checksum for sequence 2
unsigned char dic_crc_check[4];			// 2CRC

// Source address
unsigned char in_addr_sram[4]  = {0x00, 0x01, 0x80, 0x00};    // Skip the first 256 bytes of sram, due to the definition for near_area 
unsigned char in_addr_flash[4] = {0x00, 0x00, 0x40, 0x00};
unsigned char in_addr_rom[4]   = {0x00, 0x00, 0x00, 0x00};

unsigned char dic_result;					// The DIC Result from cmp_crc


//*********************************************************************
// 	: DIC_Setup()
// 	: DIC ãָ
// ע		: Set up this DIC object for CRC with the specified parameters
//*********************************************************************
void DIC_Setup(unsigned char int_disable_enable)
{
    CRCCR0 = 0x00;         					// ʼ CRC
    CRCCR1 = 0x02;         					// ʼ CRC
    DICCR  = 0x00;          				// ʼ DIC

}


//*********************************************************************
// 	: DIC_Get_result()
// 	: õDIC CRC
// ע		: dic_data Pointer to the 4 Bytes data for DIC.
//*********************************************************************
void DIC_Get_result(unsigned char  *dic_data)
{
	// CRCDO0CRCDO1 CRCĴ
	dic_data[0] = CRCDO0;					//	ȶCRCDO0ٶCRCDO1  
	dic_data[1] = CRCDO1;
	dic_data[2] = 0;						
	dic_data[3] = 0;							
}


//*********************************************************************
// 	: DIC_Done()
// 	: ֵָʾDICǷ
// ע		: 
//*********************************************************************
unsigned char DIC_Done()
{
	return(DICCR_DONE);					// 1:DIC/״̬ ; 0:DIC
	
}


//*********************************************************************
// 	: DIC_Check()
// 	: ָľ͵ݣ¼Եļ
// ע		: src Pointer to the data to check. 
//			  The length of the data to check in bytes.
//*********************************************************************
void DIC_Check(unsigned char *src, size_t length)
{
    CRCCR0 = 0x00;         					// ʼ CRC
    CRCCR1 = 0x02;         					// ʼ CRC
    DICCR  = 0x00;          				// ʼ DIC
    CRCCR0 = 0x01;         					//  CRC	
	
    DICCNT0 = length & 0xff;				// DIC ݳȼĴ0
    DICCNT1 = (length & 0xff00) >>8;;		// DIC ݳȼĴ1

    // DIC 32 λַĴ,ʼλַ
    DICADR0 = src[0];
    DICADR1 = src[1];
    DICADR2 = src[2];
    DICADR3 = src[3];
	
    DICCR = 0x01;          					//  DIC
}


//*********************************************************************
// 	: DIC_Disable()
// 	: ֹͣDICDICеϢ
// ע		: Erase any sensitive information in this DIC object.
//*********************************************************************
void DIC_Disable()
{
	DICCR  = 0x00;							// ֹͣ DIC
	CRCCR1 = 0x00;
	CRCCR0 = 0x00;
}


//*********************************************************************
// 	: Cmp_CRC()
// 	: ȽCRC֮ 
// ע		: CRC֮ͬش0       
//*********************************************************************
unsigned char Cmp_CRC(unsigned char *crc1, unsigned char *crc2)
{
	unsigned char i;
	for(i=0;i<4;i++)
	{
		if(crc1[i] != crc2[i]) return(i+1);
	}
	
	return(0);
}


//*********************************************************************
// 	: __interrupt DIC()
// 	: DICжӳ
// ע		:
//*********************************************************************
void __interrupt IntDIC(void){
	__asm("NOP");							// ָ



}


